#include <LDateTime.h>

datetimeInfo t;
unsigned int rtc;

#include <LGSM.h>

#include <LBT.h>
#include <LBTServer.h>

#include <LTask.h>
#include "vmthread.h"
#include "stddef.h"
#include <LWiFi.h>
#include <LWiFiClient.h>

#define WIFI_AP "SSID" //put the name of your wireless network here
#define WIFI_PASSWORD ""
#define WIFI_AUTH LWIFI_OPEN  // choose from LWIFI_OPEN, LWIFI_WPA, or LWIFI_WEP.
#define SITE_URL "api.mediatek.com" //the site of the API

#define DEVICEID "XXXXXXXX" // device id 
#define DEVICEKEY "YYYYYYYYYYYYYYYY" // device key 

LWiFiClient connection;


#include <dht11.h> //include library of DHT11 sensor
dht11 DHT11;
#define DHT11PIN 4
float humidity;
float temperature;

String humidity_s = "";
String temperature_s = "";

#include <LBattery.h>
String battery = "";
String charging = "";

int redLightLevel = 25;
int whiteLightLevel = 18;



int trigPin1 = 6;
int echoPin1 = 7;
long timeNoSee1, wayAway1;
long tank1_depth = 25; // in cm
long tank1_level = 0;

int trigPin2 = 2;
int echoPin2 = 5;
long timeNoSee2, wayAway2;
long tank2_depth = 25; // in cm
long tank2_level = 0;

int trigPin3 = 8;
int echoPin3 = 10;
long timeNoSee3, wayAway3;
long tank3_depth = 25; // in cm
long tank3_level = 0;

long L1l = 5;  // to set
long L2l = 5;  // to set
long L3h = 20;  // to set

uint32_t analogPin = A0;
uint32_t conductivityval = 0;
uint32_t  Sl, Sh;

const int pwm_white = 3;
const int pwm_red = 9;

int IN1a = 0;
int IN2a = 11;
int IN1b = 12;
int IN2b = 13;
int IN1c = 18;
int IN2c = 19;

String alarm = "no";

String Status;

void setup()
{
  //Serial.begin(115200);
  Status = "S0";
  pinMode(IN1a, OUTPUT);
  pinMode(IN2a, OUTPUT);
  pinMode(IN1b, OUTPUT);
  pinMode(IN2b, OUTPUT);
  pinMode(IN1c, OUTPUT);
  pinMode(IN2c, OUTPUT);
  closeVa();
  closeVb();
  closeVc();
  t.year = getValue(__DATE__, ' ', 3).toInt();
  t.mon = getMonth(getValue(__DATE__, ' ', 0));
  t.day = getValue(__DATE__, ' ', 2).toInt();
  t.hour = getValue(__TIME__, ':', 0).toInt();
  t.min = getValue(__TIME__, ':', 1).toInt();
  t.sec = getValue(__TIME__, ':', 2).toInt();
  LDateTime.setTime(&t);
  
  if(!LBTServer.begin((uint8_t*)"My_Hydroponics"))
  {
    //Serial.println("Fail to start BT.");
    return;
  }
    //Serial.println("BT server is started.");
  
  while(!LSMS.ready())
    delay(1000);
    
  pinMode(echoPin1, INPUT);
  pinMode(trigPin1, OUTPUT);
  pinMode(echoPin2, INPUT);
  pinMode(trigPin2, OUTPUT);
  pinMode(echoPin3, INPUT);
  pinMode(trigPin3, OUTPUT);
  LWiFi.begin();
  
  while(!Serial);
  // keep retrying until connected to AP
  //Serial.println("Connecting to AP");
  while (0 == LWiFi.connect(WIFI_AP, LWiFiLoginInfo(WIFI_AUTH, WIFI_PASSWORD)))
  {
    delay(1000);
  }

  LTask.remoteCall(createThread, NULL);
  LTask.remoteCall(createThread1, NULL);
  LTask.remoteCall(createThread2, NULL);
  LTask.remoteCall(createThread3, NULL);
  LTask.remoteCall(createThread4, NULL);
  LTask.remoteCall(createThread5, NULL);
}

boolean disconnectedMsg = false;

void loop()
{
  if (wayAway1 < tank1_depth) {
    tank1_level = tank1_depth - wayAway1;
  } else {
    tank1_level = 0;
  }

  if (wayAway2 < tank2_depth) {
    tank2_level = tank2_depth - wayAway2;
  } else {
    tank2_level = 0;
  }

  if (wayAway3 < tank3_depth) {
    tank3_level = tank3_depth - wayAway3;
  } else {
    tank3_level = 0;
  }
  
  char bufferH[5];
  char bufferT[5];
 
  sprintf(bufferH, "%.0f", humidity);
  sprintf(bufferT, "%.0f", temperature);

  humidity_s = String(bufferH);
  temperature_s = String(bufferT);
  

  String uploadHumidity = "humidity_display,," + humidity_s;
  String uploadTemperature = "temperature_display,," + temperature_s;
  String uploadBattery = "battery_display,," + battery;
  String uploadIsCharging = "ischarging_display,," + charging;
  String uploadLevel1 = "level1_display,," + (String) tank1_level;
  String uploadLevel2 = "level2_display,," + (String) tank2_level;
  String uploadLevel3 = "level3_display,," + (String) tank3_level;
  String uploadConductivity = "conductivity_display,," + (String) conductivityval;
  String uploadRedLevel = "redlevel_display,," + (String) redLightLevel;
  String uploadWhiteLevel = "whitelevel_display,," + (String) whiteLightLevel;

  
  String uploadData = uploadHumidity + "\n" +
                      uploadTemperature + "\n" + 
                      uploadBattery + "\n" + 
                      uploadIsCharging + "\n" +
                      uploadLevel1 + "\n" +
                      uploadLevel2 + "\n" +
                      uploadLevel3 + "\n" +
                      uploadConductivity + "\n" +
                      uploadRedLevel + "\n" +                      
                      uploadWhiteLevel + "\n";

  //Serial.println(uploadData);
  
  
  //Serial.println("Connecting to WebSite");


  delay(5000);
  
  while (0 == connection.connect(SITE_URL, 80))
  {
    //Serial.println("Re-Connecting to WebSite");
    delay(1000);
  }



  connection.print("POST /mcs/v2/devices/");
  connection.print(DEVICEID);
  connection.println("/datapoints.csv HTTP/1.1");
  connection.print("Host: ");
  connection.println(SITE_URL);
  connection.print("deviceKey: ");
  connection.println(DEVICEKEY);
  connection.print("Content-Length: ");
  connection.println(uploadData.length());
  connection.println("Content-Type: text/csv");
  connection.println("Connection: close");
  connection.println();
  connection.println(uploadData);
  



  // waiting for server response
  //Serial.println("waiting HTTP response:");
  while (!connection.available())
  {
    delay(100);
  }


  
  // Make sure we are connected, and dump the response content to Serial
  while (connection)
  {
    int v = connection.read();
    if (v != -1)
    {
      ////Serial.print((char)v);
    }
    else
    {
      //Serial.println("no more content, disconnect");
      connection.stop();

    }
  }

  if (!disconnectedMsg)
  {
    //Serial.println("disconnected by server");
    disconnectedMsg = true;
  }
  delay(500);

  
}

boolean createThread(void* userdata) {
        // The priority can be 1 - 255 and default priority are 0
        // the arduino priority are 245
        vm_thread_create(test_thread, NULL, 0);
  return true;
}

boolean createThread1(void* userdata) {
        // The priority can be 1 - 255 and default priority are 0
        // the arduino priority are 245
        vm_thread_create(test_thread1, NULL, 0);
  return true;
}

boolean createThread2(void* userdata) {
        // The priority can be 1 - 255 and default priority are 0
        // the arduino priority are 245
        vm_thread_create(test_thread2, NULL, 0);
  return true;
}

boolean createThread3(void* userdata) {
        // The priority can be 1 - 255 and default priority are 0
        // the arduino priority are 245
        vm_thread_create(test_thread3, NULL, 0);
  return true;
}

boolean createThread4(void* userdata) {
        // The priority can be 1 - 255 and default priority are 0
        // the arduino priority are 245
        vm_thread_create(test_thread4, NULL, 0);
  return true;
}

boolean createThread5(void* userdata) {
        // The priority can be 1 - 255 and default priority are 0
        // the arduino priority are 245
        vm_thread_create(test_thread5, NULL, 0);
  return true;
}

VMINT32 test_thread(VM_THREAD_HANDLE thread_handle, void* user_data)
{
  for (;;)
  {

    
    String uploadData = "Temperature: " + temperature_s + "°C\n" +
                        "Humidity: " + humidity_s + "%\n" +
                        "Battery: " + battery + "%\n" +
                        "Battery charging: " + charging + "\n" +
                        "Tank 1 level: " + tank1_level + "\n" +
                        "Tank 2 level: " + tank2_level + "\n" +     
                        "Tank 3 level: " + tank3_level + "\n" + 
                        "Conductivity: " + conductivityval + "uS\n" +
                        "Red light level: " + whiteLightLevel + "%\n" +
                        "White light level: " + redLightLevel + "%\n";

 
      String message = "";
      message = SMS_rx();
      //Serial.println(message);
      //message = message.toLowerCase();

      if (message == "info")
      {
        SMS_tx(uploadData);
      }
      else if (message == "test")
      {
        SMS_tx("Hydroponic system: ready!");
      }
      else
      {
        // do Thing C
      }


    delay(10000);
    
  }
  return 0;
}




VMINT32 test_thread1(VM_THREAD_HANDLE thread_handle, void* user_data)
{
  for (;;)
  {
    conductivityval = analogRead(analogPin);

    conductivityval = 1000 / (33 *((1024 - conductivityval)/conductivityval));  // in uS
    
    

    int chk = DHT11.read(DHT11PIN); //check DHT11 and read values
    humidity = DHT11.humidity;
    temperature = DHT11.temperature;

    battery = (String) LBattery.level();
    charging = (String) LBattery.isCharging();

    // Tank 1
    digitalWrite(trigPin1, LOW);
    delayMicroseconds(2);
    digitalWrite(trigPin1, HIGH);
    delayMicroseconds(1000);
    digitalWrite(trigPin1, LOW);
    timeNoSee1 = pulseIn(echoPin1, HIGH);
    wayAway1 = timeNoSee1 / 58.2;
    ////Serial.print("distanza: ");
    ////Serial.println(wayAway1);

    // Tank 2
    digitalWrite(trigPin2, LOW);
    delayMicroseconds(2);
    digitalWrite(trigPin2, HIGH);
    delayMicroseconds(1000);
    digitalWrite(trigPin2, LOW);
    timeNoSee2 = pulseIn(echoPin2, HIGH);
    wayAway2 = timeNoSee2 / 58.2;

    // Tank 3
    digitalWrite(trigPin3, LOW);
    delayMicroseconds(2);
    digitalWrite(trigPin3, HIGH);
    delayMicroseconds(1000);
    digitalWrite(trigPin3, LOW);
    timeNoSee3 = pulseIn(echoPin3, HIGH);
    wayAway3 = timeNoSee3 / 58.2;

    delay(4000);
  }
  return 0;
}





VMINT32 test_thread2(VM_THREAD_HANDLE thread_handle, void* user_data)
{
  for (;;)
  {

    uint8_t buf[64];
    int bytesRead;
    String msg = "";
    
    if(LBTServer.connected())
    {
      while(true)
      {
        bytesRead = LBTServer.readBytes(buf, 64);
        if(!bytesRead)
          break;

        msg = msg + (char*)(buf);

      }
      for( int i = 0; i < sizeof(buf);  ++i )
        buf[i] = (char)0;
      //Serial.print(msg);

      delay(100);
    }
    else
    {
      LBTServer.accept(5);
    }

    
    String uploadData = "Temperature: " + temperature_s + "°C\n" +
                        "Humidity: " + humidity_s + "%\n" +
                        "Battery: " + battery + "%\n" +
                        "Battery charging: " + charging + "\n" +
                        "Tank 1 level: " + tank1_level + "\n" +
                        "Tank 2 level: " + tank2_level + "\n" +     
                        "Tank 3 level: " + tank3_level + "\n" + 
                        "Conductivity: " + conductivityval + "uS\n" +
                        "Red light level: " + whiteLightLevel + "%\n" +
                        "White light level: " + redLightLevel + "%\n";


      //message = message.toLowerCase();

      if (msg == "info")
      {
        LBTServer.print(uploadData);
      }
      else if (msg == "test")
      {
        LBTServer.print("Hydroponic system: ready!");
      }
      else
      {
        // do Thing C
      }


    delay(1000);
    
  }
  return 0;
}


VMINT32 test_thread3(VM_THREAD_HANDLE thread_handle, void* user_data)
{
  for (;;)
  {
    if(t.mon == 12 or t.mon == 1 or t.mon == 2) {
      winter();
    } else if(t.mon == 3 or t.mon == 4 or t.mon == 5) {
      spring();
    } else if(t.mon == 6 or t.mon == 7 or t.mon == 8) {
      summer();
    } else if(t.mon == 9 or t.mon == 10 or t.mon == 11) {
      autumn();
    }

    //Serial.println(redLightLevel);
    //Serial.println(whiteLightLevel);
  
    analogWrite(pwm_white, whiteLightLevel * 10.24);
    analogWrite(pwm_red, redLightLevel * 10.24);
  }
  return 0;
}

VMINT32 test_thread4(VM_THREAD_HANDLE thread_handle, void* user_data)
{
  for (;;)
  {
    if(Status == "S0") {
      if(tank3_level > tank3_level/2) {
        closeVa();
        closeVb();
        closeVc();
        Status = "S3";
      } else if(tank3_level <= tank3_level/2) {
        closeVa();
        closeVb();
        closeVc();
        Status = "S1";
      }    
  } else if(Status == "S1") {
      if(tank1_level <= L1l || tank2_level <= L2l) {
        closeVa();
        closeVb();
        closeVc();
        Status = "S2";
      } else if(tank1_level > L1l && tank2_level > L2l) {
        openVa();
        openVb();
        Status = "S0";
      }
  } else if(Status == "S2") {   
       closeVa();
       closeVb();
       closeVc();
       alarm = "yes";
       Status = "S2";
  } else if(Status == "S3") {
      if(tank3_level >= L3h) {
        closeVa();
        closeVb();
        openVc();
        Status = "S0";
      } else if(tank3_level < L3h) {
        closeVa();
        closeVb();
        closeVc();
        Status = "S4";
      }
  } else if(Status == "S4") {
      if(conductivityval < Sh && conductivityval > Sl) {
        closeVa();
        closeVb();
        closeVc();
        Status = "S0";
      } else if(conductivityval < Sl) {
        closeVa();
        closeVb();
        closeVc();
        Status = "S5";
      } else if(conductivityval > Sh) {
        closeVa();
        closeVb();
        closeVc();
        Status = "S6";
      }
  } else if(Status == "S5") {
      if(tank1_level <= L1l || tank2_level <= L2l) {
        closeVa();
        closeVb();
        closeVc();
        Status = "S2";
      } else if(tank1_level > L1l && tank2_level > L2l) {
        closeVa();
        openVb();
        closeVc();
        Status = "S4";
      }
  } else if(Status == "S6") {  
      if(tank1_level <= L1l || tank2_level <= L2l) {
        closeVa();
        closeVb();
        closeVc();
        Status = "S2";
      } else if(tank1_level > L1l && tank2_level > L2l) {
        openVa();
        closeVb();
        closeVc();
        Status = "S4";
      }
  } 
  delay(2000);  // to set
  }
  return 0;
}

VMINT32 test_thread5(VM_THREAD_HANDLE thread_handle, void* user_data)
{
  for (;;)
  {
    if (alarm = "yes") {
      SMS_tx("Empty tanks");
    }
    delay(7200000);  // an sms every 2 hours
  }
  return 0;
}

boolean SMS_tx(String msg){
    LSMS.beginSMS("0123456789"); // put the SIM number here
    LSMS.print(msg);
    if(LSMS.endSMS())
    {
      return true;
    }
    else
    {
      return false;
    }
}


String SMS_rx() {
  char buf[20];
  int v;
  String msg = "";
  
  if(LSMS.available()) // Check if there is new SMS
  {

    while(true)
    {
      v = LSMS.read();
      if(v < 0)
      break;
      msg = msg + (char)v;
    }
    //Serial.println();
    LSMS.flush(); // delete message
  }
  delay(1000);

  return msg;
}


void winter() {
  switch (t.hour) {
   case 0:
   case 1:
   case 2:
   case 3:
   case 4:
   case 5:
   case 6:
     redLightLevel = 10;
     whiteLightLevel = 10;
     break;
   case 7:
     redLightLevel = 20;
     whiteLightLevel = 20;
     break;
   case 8:
     redLightLevel = 30;
     whiteLightLevel = 30;
     break;
   case 9:
     redLightLevel = 40;
     whiteLightLevel = 40;
     break;
   case 10:
     redLightLevel = 50;
     whiteLightLevel = 50;
     break;
   case 11:
     redLightLevel = 60;
     whiteLightLevel = 60;
     break;
   case 12:
     redLightLevel = 70;
     whiteLightLevel = 70;
     break;
   case 13:
     redLightLevel = 60;
     whiteLightLevel = 60;
     break;
   case 14:
     redLightLevel = 50;
     whiteLightLevel = 50;
     break;
   case 15:
     redLightLevel = 40;
     whiteLightLevel = 40;
     break;
   case 16:
     redLightLevel = 30;
     whiteLightLevel = 30;
     break;
   case 17:
     redLightLevel = 20;
     whiteLightLevel = 20;
     break;
   case 18:
   case 19:
   case 20:
   case 21:
   case 22:
   case 23:
     redLightLevel = 0;
     whiteLightLevel = 0;
     break;
 }
}

void spring() {
  switch (t.hour) {
   case 0:
   case 1:
   case 2:
   case 3:
   case 4:
   case 5:
   case 6:
     redLightLevel = 20;
     whiteLightLevel = 20;
     break;
   case 7:
     redLightLevel = 30;
     whiteLightLevel = 30;
     break;
   case 8:
     redLightLevel = 40;
     whiteLightLevel = 40;
     break;
   case 9:
     redLightLevel = 50;
     whiteLightLevel = 50;
     break;
   case 10:
     redLightLevel = 60;
     whiteLightLevel = 60;
     break;
   case 11:
     redLightLevel = 70;
     whiteLightLevel = 70;
     break;
   case 12:
     redLightLevel = 80;
     whiteLightLevel = 80;
     break;
   case 13:
     redLightLevel = 70;
     whiteLightLevel = 70;
     break;
   case 14:
     redLightLevel = 60;
     whiteLightLevel = 60;
     break;
   case 15:
     redLightLevel = 50;
     whiteLightLevel = 50;
     break;
   case 16:
     redLightLevel = 40;
     whiteLightLevel = 40;
     break;
   case 17:
     redLightLevel = 30;
     whiteLightLevel = 30;
     break;
   case 18:
     redLightLevel = 20;
     whiteLightLevel = 20;
     break;
   case 19:
     redLightLevel = 10;
     whiteLightLevel = 10;
     break;
   case 20:
   case 21:
   case 22:
   case 23:
     redLightLevel = 0;
     whiteLightLevel = 0;
     break;
 }
}

void summer() {
  switch (t.hour) {
   case 0:
   case 1:
   case 2:
   case 3:
   case 4:
   case 5:
     redLightLevel = 20;
     whiteLightLevel = 20;
     break;
   case 6:
     redLightLevel = 30;
     whiteLightLevel = 30;
     break;
   case 7:
     redLightLevel = 40;
     whiteLightLevel = 40;
     break;
   case 8:
     redLightLevel = 50;
     whiteLightLevel = 50;
     break;
   case 9:
     redLightLevel = 60;
     whiteLightLevel = 60;
     break;
   case 10:
     redLightLevel = 70;
     whiteLightLevel = 70;
     break;
   case 11:
     redLightLevel = 80;
     whiteLightLevel = 80;
     break;
   case 12:
     redLightLevel = 90;
     whiteLightLevel = 90;
     break;
   case 13:
     redLightLevel = 80;
     whiteLightLevel = 80;
     break;
   case 14:
     redLightLevel = 70;
     whiteLightLevel = 70;
     break;
   case 15:
     redLightLevel = 60;
     whiteLightLevel = 60;
     break;
   case 16:
     redLightLevel = 50;
     whiteLightLevel = 50;
     break;
   case 17:
     redLightLevel = 40;
     whiteLightLevel = 40;
     break;
   case 18:
     redLightLevel = 30;
     whiteLightLevel = 30;
     break;
   case 19:
     redLightLevel = 20;
     whiteLightLevel = 20;
     break;
   case 20:
     redLightLevel = 10;
     whiteLightLevel = 10;
     break;
   case 21:
   case 22:
   case 23:
     redLightLevel = 0;
     whiteLightLevel = 0;
     break;
 }
}

void autumn() {
  switch (t.hour) {
   case 0:
   case 1:
   case 2:
   case 3:
   case 4:
   case 5:
   case 6:
     redLightLevel = 10;
     whiteLightLevel = 10;
     break;
   case 7:
     redLightLevel = 20;
     whiteLightLevel = 20;
     break;
   case 8:
     redLightLevel = 30;
     whiteLightLevel = 30;
     break;
   case 9:
     redLightLevel = 40;
     whiteLightLevel = 40;
     break;
   case 10:
     redLightLevel = 50;
     whiteLightLevel = 50;
     break;
   case 11:
     redLightLevel = 60;
     whiteLightLevel = 60;
     break;
   case 12:
     redLightLevel = 70;
     whiteLightLevel = 70;
     break;
   case 13:
     redLightLevel = 60;
     whiteLightLevel = 60;
     break;
   case 14:
     redLightLevel = 50;
     whiteLightLevel = 50;
     break;
   case 15:
     redLightLevel = 40;
     whiteLightLevel = 40;
     break;
   case 16:
     redLightLevel = 30;
     whiteLightLevel = 30;
     break;
   case 17:
     redLightLevel = 20;
     whiteLightLevel = 20;
     break;
   case 18:
     redLightLevel = 10;
     whiteLightLevel = 10;
     break;
   case 19:
   case 20:
   case 21:
   case 22:
   case 23:
     redLightLevel = 0;
     whiteLightLevel = 0;
     break;
 }
}

String getValue(String data, char separator, int index)
{
  int found = 0;
  int strIndex[] = {
    0, -1  };
  int maxIndex = data.length()-1;

  for(int i=0; i<=maxIndex && found<=index; i++){
    if(data.charAt(i)==separator || i==maxIndex){
      found++;
      strIndex[0] = strIndex[1]+1;
      strIndex[1] = (i == maxIndex) ? i+1 : i;
    }
  }
  return found>index ? data.substring(strIndex[0], strIndex[1]) : "";
}

int getMonth(String month_s) {
  if (month_s == "Jan")
  {
    return 1;
  }
  else if (month_s == "Feb")
  {
    return 2;
  }
  else if (month_s == "Mar")
  {
    return 3;
  }
  else if (month_s == "Apr")
  {
    return 4;
  }
  else if (month_s == "May")
  {
    return 5;
  }
  else if (month_s == "Jun")
  {
    return 6;
  }
  else if (month_s == "Jul")
  {
    return 7;
  }
  else if (month_s == "Aug")
  {
    return 8;
  }
  else if (month_s == "Sep")
  {
    return 9;
  }
  else if (month_s == "Oct")
  {
    return 10;
  }
  else if (month_s == "Nov")
  {
    return 11;
  }
  else if (month_s == "Dec")
  {
    return 12;
  }
}

void closeVa() {
  digitalWrite(IN1a, LOW);
  digitalWrite(IN2a, HIGH);
}

void closeVb() {
  digitalWrite(IN1b, LOW);
  digitalWrite(IN2b, HIGH);
}

void closeVc() {
  digitalWrite(IN1c, LOW);
  digitalWrite(IN2c, HIGH);
}

void openVa() {
  digitalWrite(IN1a, HIGH);
  digitalWrite(IN2a, LOW);
}

void openVb() {
  digitalWrite(IN1b, HIGH);
  digitalWrite(IN2b, LOW);
}

void openVc() {
  digitalWrite(IN1c, HIGH);
  digitalWrite(IN2c, LOW);
}

void zeroVa() {
  digitalWrite(IN1a, LOW);
  digitalWrite(IN2a, LOW);
}

void zeroVb() {
  digitalWrite(IN1b, LOW);
  digitalWrite(IN2b, LOW);
}

void zeroVc() {
  digitalWrite(IN1c, LOW);
  digitalWrite(IN2c, LOW);
}


